/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ije.exam3;

import java.util.HashSet;
import java.util.Set;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author coki
 * Implement the small application for the school. Implement classes Semester, Course, OpenCourse, and Student. 
 * These classes represent the semester (term), the course (general information), the open course (the course 
 * opened in the given year), and the student. Each open course is for the given course and is stored 
 * in the semester object. Each student can be registered to the open course and can get points in the course.
 * Implement all required methods and constructors in accordance 
 * with following test methods (test01, test02, test03, and test04).
 */
public class CourseTest {

    @Test // 7 points
    public void test01() {
        Set<Student> as = new HashSet<Student>();
        // each student is identified by his/her name
        Student s1 = new Student("Student1");
        Student s2 = new Student("Student2");
        as.add(s1);
        as.add(s2);
        assertTrue(as.contains(new Student("Student1")));
    }
    
    @Test // 10 points
    public void test02() {
        // each course is specified by it name, number of credits, and the maximum number of points
        Course c1 = new Course("course1", 5, 100);
        Course c2 = new Course("course1", 5, 60);
        
        assertEquals(100, c1.maxPoints());
        assertEquals(60, c2.maxPoints());
        
        Student s1 = new Student("Student1");
        Student s2 = new Student("Student2");
        
        // the course c1 is opened for the year 2007
        OpenCourse oc1 = new OpenCourse(c1, 2007);
        
        // the student s1 is registered to the open course oc1
        oc1.registerStudent(s1);
        assertTrue(oc1.isStudentRegistered(s1));
        assertFalse(oc1.isStudentRegistered(s2));

        // the student s2 is registered to the open course oc1
        oc1.registerStudent(s2);
        assertTrue(oc1.isStudentRegistered(s1));
        assertTrue(oc1.isStudentRegistered(s2));        
    }

    @Test // 10 points
    public void test03() {
        Course c1 = new Course("course1", 5, 70);
        Student s1 = new Student("Student1");
        OpenCourse oc1 = new OpenCourse(c1, 2007);

        oc1.registerStudent(s1);
        
        // it is impossible to add 110 point, because the maximum number of points in this course is 70
        assertFalse(oc1.addPoints(s1, 110));
        // it is possible to add 30 points
        assertTrue(oc1.addPoints(s1, 30));
        // it is possible to add 15 points
        assertTrue(oc1.addPoints(s1, 15));
        // it is impossible to add 50 points, because the student already has 45 points and the maximum 
        // number of points in this course is 70
        assertFalse(oc1.addPoints(s1, 50));
        // the student s1 has got 45 points
        assertEquals(45, oc1.getPoints(s1));
    }

    @Test // 10 points
    public void test04() {
        Semester sem = new Semester();
        Course c1 = new Course("course1", 5, 100);
        Course c2 = new Course("course1", 5, 60);
        Student s1 = new Student("Student1");
        Student s2 = new Student("Student2");
        OpenCourse oc1 = new OpenCourse(c1, 2007);
        OpenCourse oc2 = new OpenCourse(c2, 2008);
        oc1.registerStudent(s1);
        oc1.registerStudent(s2);
        oc2.registerStudent(s1);
        
        // it adds open courses oc1 and oc2 into the semester
        sem.addCourse(oc1);
        sem.addCourse(oc2);

        // the student s1 has registered two open courses
        Set<OpenCourse> oc = sem.coursesOfStudent(s1);
        assertEquals(2, oc.size());
        assertTrue(oc.contains(oc1));
        assertTrue(oc.contains(oc2));

        // the student s2 has registered one open course
        oc = sem.coursesOfStudent(s2);
        assertEquals(1, oc.size());
        assertTrue(oc.contains(oc1));
        assertFalse(oc.contains(oc2));
    }

    public CourseTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

}